Index: bitlbee.c
===================================================================
--- bitlbee.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ bitlbee.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,3 +1,3 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -27,326 +27,575 @@
 #include "bitlbee.h"
 #include "commands.h"
+#include "crypting.h"
 #include "protocols/nogaim.h"
 #include "help.h"
-#include "ipc.h"
 #include <signal.h>
 #include <stdio.h>
 #include <errno.h>
 
-static gboolean bitlbee_io_new_client(gpointer data, gint fd, b_input_condition condition);
-
-static gboolean try_listen(struct addrinfo *res)
-{
+gboolean bitlbee_io_new_client( GIOChannel *source, GIOCondition condition, gpointer data )
+{
+	size_t size = sizeof( struct sockaddr_in );
+	struct sockaddr_in conn_info;
+	int new_socket = accept( global.listen_socket, (struct sockaddr *) &conn_info, 
+		                     &size );
+	
+	count_io_event(source, "main");
+	
+	log_message( LOGLVL_INFO, "Creating new connection with fd %d.", new_socket );
+	irc_new( new_socket );
+
+	return TRUE;
+}
+ 
+
+
+int bitlbee_daemon_init()
+{
+	struct sockaddr_in listen_addr;
 	int i;
-
-	global.listen_socket = socket(res->ai_family, res->ai_socktype, res->ai_protocol);
-	if (global.listen_socket < 0) {
-		log_error("socket");
-		return FALSE;
-	}
-
-#ifdef IPV6_V6ONLY
-	if (res->ai_family == AF_INET6) {
-		i = 0;
-		setsockopt(global.listen_socket, IPPROTO_IPV6, IPV6_V6ONLY,
-		           (char *) &i, sizeof(i));
+	GIOChannel *ch;
+	
+	log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
+	log_link( LOGLVL_WARNING, LOGOUTPUT_SYSLOG );
+	
+	global.listen_socket = socket( AF_INET, SOCK_STREAM, 0 );
+	if( global.listen_socket == -1 )
+	{
+		log_error( "socket" );
+		return( -1 );
+	}
+	listen_addr.sin_family = AF_INET;
+	listen_addr.sin_port = htons( global.conf->port );
+	listen_addr.sin_addr.s_addr = inet_addr( global.conf->iface );
+
+	i = bind( global.listen_socket, (struct sockaddr *) &listen_addr, sizeof( struct sockaddr ) );
+	if( i == -1 )
+	{
+		log_error( "bind" );
+		return( -1 );
+	}
+
+	i = listen( global.listen_socket, 10 );
+	if( i == -1 )
+	{
+		log_error( "listen" );
+		return( -1 );
+	}
+
+	ch = g_io_channel_unix_new( global.listen_socket );
+	g_io_add_watch( ch, G_IO_IN, bitlbee_io_new_client, NULL );
+
+#ifndef _WIN32
+	if( !global.conf->nofork )
+	{
+		i = fork();
+		if( i == -1 )
+		{
+			log_error( "fork" );
+			return( -1 );
+		}
+		else if( i != 0 ) 
+			exit( 0 );
+		close( 0 );
+		close( 1 );
+		close( 2 );
+		chdir( "/" );
 	}
 #endif
-
-	/* TIME_WAIT (?) sucks.. */
-	i = 1;
-	setsockopt(global.listen_socket, SOL_SOCKET, SO_REUSEADDR, &i, sizeof(i));
-
-	i = bind(global.listen_socket, res->ai_addr, res->ai_addrlen);
-	if (i == -1) {
-		closesocket(global.listen_socket);
-		global.listen_socket = -1;
-
-		log_error("bind");
-		return FALSE;
-	}
-
-	return TRUE;
-}
-
-int bitlbee_daemon_init()
-{
-	struct addrinfo *res, hints, *addrinfo_bind;
-	int i;
-	FILE *fp;
-
-	log_link(LOGLVL_ERROR, LOGOUTPUT_CONSOLE);
-	log_link(LOGLVL_WARNING, LOGOUTPUT_CONSOLE);
-
-	memset(&hints, 0, sizeof(hints));
-	hints.ai_family = PF_UNSPEC;
-	hints.ai_socktype = SOCK_STREAM;
-	hints.ai_flags = AI_PASSIVE
-#ifdef AI_ADDRCONFIG
-	                 /* Disabled as it may be doing more harm than good: this flag
-	                    ignores IPv6 addresses on lo (which seems reasonable), but
-	                    the result is that some clients (including irssi) try to
-	                    connect to ::1 and fail.
-	                                | AI_ADDRCONFIG */
-#endif
-	;
-
-	i = getaddrinfo(global.conf->iface_in, global.conf->port, &hints, &addrinfo_bind);
-	if (i) {
-		log_message(LOGLVL_ERROR, "Couldn't parse address `%s': %s",
-		            global.conf->iface_in, gai_strerror(i));
-		return -1;
-	}
-
-	global.listen_socket = -1;
-
-	/* Try IPv6 first (which will become an IPv6+IPv4 socket). */
-	for (res = addrinfo_bind; res; res = res->ai_next) {
-		if (res->ai_family == AF_INET6 && try_listen(res)) {
-			break;
-		}
-	}
-
-	/* The rest (so IPv4, I guess). */
-	if (res == NULL) {
-		for (res = addrinfo_bind; res; res = res->ai_next) {
-			if (res->ai_family != AF_INET6 && try_listen(res)) {
-				break;
-			}
-		}
-	}
-
-	freeaddrinfo(addrinfo_bind);
-
-	if (global.listen_socket == -1 && errno == EADDRINUSE) {
-		log_message(LOGLVL_ERROR, "Can't listen on port %s. Is another bitlbee already running?",
-		            global.conf->port);
-		return(-1);
-	}
-
-	i = listen(global.listen_socket, 10);
-	if (i == -1) {
-		log_error("listen");
-		return(-1);
-	}
-
-	global.listen_watch_source_id = b_input_add(global.listen_socket, B_EV_IO_READ, bitlbee_io_new_client, NULL);
-
-	if (!global.conf->nofork) {
-		i = fork();
-		if (i == -1) {
-			log_error("fork");
-			return(-1);
-		} else if (i != 0) {
-			exit(0);
-		}
-
-		setsid();
-		i = chdir("/");
-		/* Don't use i, just make gcc happy. :-/ */
-
-		if (getenv("_BITLBEE_RESTART_STATE") == NULL) {
-			for (i = 0; i < 3; i++) {
-				if (close(i) == 0) {
-					/* Keep something bogus on those fd's just in case. */
-					open("/dev/null", O_WRONLY);
-				}
-			}
-		}
-	}
-
-	if (global.conf->runmode == RUNMODE_FORKDAEMON) {
-		ipc_master_load_state(getenv("_BITLBEE_RESTART_STATE"));
-	}
-
-	if (global.conf->runmode == RUNMODE_DAEMON || global.conf->runmode == RUNMODE_FORKDAEMON) {
-		ipc_master_listen_socket();
-	}
-
-	if ((fp = fopen(global.conf->pidfile, "w"))) {
-		fprintf(fp, "%d\n", (int) getpid());
-		fclose(fp);
-	} else {
-		log_message(LOGLVL_WARNING, "Warning: Couldn't write PID to `%s'", global.conf->pidfile);
-	}
-
-	if (!global.conf->nofork) {
-		log_link(LOGLVL_ERROR, LOGOUTPUT_SYSLOG);
-		log_link(LOGLVL_WARNING, LOGOUTPUT_SYSLOG);
-	}
-
-	return(0);
-}
-
+	
+	return( 0 );
+}
+ 
 int bitlbee_inetd_init()
 {
-	if (!irc_new(0)) {
-		return(1);
-	}
-
-	return(0);
-}
-
-gboolean bitlbee_io_current_client_read(gpointer data, gint fd, b_input_condition cond)
+	if( !irc_new( 0 ) )
+		return( 1 );
+	
+	log_link( LOGLVL_ERROR, LOGOUTPUT_IRC );
+	log_link( LOGLVL_WARNING, LOGOUTPUT_IRC );
+	
+	return( 0 );
+}
+
+gboolean bitlbee_io_current_client_read( GIOChannel *source, GIOCondition condition, gpointer data )
 {
 	irc_t *irc = data;
 	char line[513];
 	int st;
-
-	st = read(irc->fd, line, sizeof(line) - 1);
-	if (st == 0) {
-		irc_abort(irc, 1, "Connection reset by peer");
+	
+	count_io_event(source, "main");
+
+	if( condition & G_IO_ERR || condition & G_IO_HUP )
+	{
+		irc_free( irc );
 		return FALSE;
-	} else if (st < 0) {
-		if (sockerr_again()) {
+	}
+	
+	st = read( irc->fd, line, sizeof( line ) - 1 );
+	if( st == 0 )
+	{
+		irc_free( irc );
+		return FALSE;
+	}
+	else if( st < 0 )
+	{
+		if( sockerr_again() )
+		{
 			return TRUE;
-		} else {
-			irc_abort(irc, 1, "Read error: %s", strerror(errno));
+		}
+		else
+		{
+			irc_free( irc );
 			return FALSE;
 		}
 	}
-
+	
 	line[st] = '\0';
-	if (irc->readbuffer == NULL) {
-		irc->readbuffer = g_strdup(line);
-	} else {
-		irc->readbuffer = g_renew(char, irc->readbuffer, strlen(irc->readbuffer) + strlen(line) + 1);
-		strcpy((irc->readbuffer + strlen(irc->readbuffer)), line);
-	}
-
-	irc_process(irc);
-
-	/* Normally, irc_process() shouldn't call irc_free() but irc_abort(). Just in case: */
-	if (!g_slist_find(irc_connection_list, irc)) {
-		log_message(LOGLVL_WARNING, "Abnormal termination of connection with fd %d.", fd);
+	if( irc->readbuffer == NULL ) 
+	{
+		irc->readbuffer = g_strdup( line );
+	}
+	else 
+	{
+		irc->readbuffer = g_renew( char, irc->readbuffer, strlen( irc->readbuffer ) + strlen ( line ) + 1 );
+		strcpy( ( irc->readbuffer + strlen( irc->readbuffer ) ), line );
+	}
+	
+	if( !irc_process( irc ) )
+	{
+		log_message( LOGLVL_INFO, "Destroying connection with fd %d.", irc->fd );
+		irc_free( irc );
 		return FALSE;
-	}
-
-	/* Very naughty, go read the RFCs! >:) */
-	if (irc->readbuffer && (strlen(irc->readbuffer) > 1024)) {
-		irc_abort(irc, 0, "Maximum line length exceeded");
-		return FALSE;
-	}
-
+	} 
+		
 	return TRUE;
 }
 
-gboolean bitlbee_io_current_client_write(gpointer data, gint fd, b_input_condition cond)
+gboolean bitlbee_io_current_client_write( GIOChannel *source, GIOCondition condition, gpointer data )
 {
 	irc_t *irc = data;
 	int st, size;
-
-	size = irc->sendbuffer->len;
-
-	if (size == 0) {
-		return FALSE;
-	}
-
-	st = write(irc->fd, irc->sendbuffer->str, size);
-
-	if (st == 0 || (st < 0 && !sockerr_again())) {
-		irc_abort(irc, 1, "Write error: %s", strerror(errno));
-		return FALSE;
-	} else if (st < 0) { /* && sockerr_again() */
-		return TRUE;
-	}
-
-	if (st == size) {
-		g_string_truncate(irc->sendbuffer, 0);
+	char *temp;
+#ifdef FLOOD_SEND
+	time_t newtime;
+#endif
+
+	count_io_event(source, "main");
+
+#ifdef FLOOD_SEND	
+	newtime = time( NULL );
+	if( ( newtime - irc->oldtime ) > FLOOD_SEND_INTERVAL )
+	{
+		irc->sentbytes = 0;
+		irc->oldtime = newtime;
+	}
+#endif
+	
+	if( irc->sendbuffer == NULL )
+		return( FALSE );
+	
+	size = strlen( irc->sendbuffer );
+	
+#ifdef FLOOD_SEND
+	if( ( FLOOD_SEND_BYTES - irc->sentbytes ) > size )
+		st = write( irc->fd, irc->sendbuffer, size );
+	else
+		st = write( irc->fd, irc->sendbuffer, ( FLOOD_SEND_BYTES - irc->sentbytes ) );
+#else
+	st = write( irc->fd, irc->sendbuffer, size );
+#endif
+	
+	if( st <= 0 )
+	{
+		if( sockerr_again() )
+		{
+			return TRUE;
+		}
+		else
+		{
+			irc_free( irc );
+			return FALSE;
+		}
+	}
+	
+#ifdef FLOOD_SEND
+	irc->sentbytes += st;
+#endif		
+	
+	if( st == size )
+	{
+		g_free( irc->sendbuffer );
+		irc->sendbuffer = NULL;
+		
 		irc->w_watch_source_id = 0;
-
-		return FALSE;
-	} else {
-		g_string_erase(irc->sendbuffer, 0, st);
-
-		return TRUE;
-	}
-}
-
-static gboolean bitlbee_io_new_client(gpointer data, gint fd, b_input_condition condition)
-{
-	socklen_t size = sizeof(struct sockaddr_in);
-	struct sockaddr_in conn_info;
-	int new_socket = accept(global.listen_socket, (struct sockaddr *) &conn_info, &size);
-
-	if (new_socket == -1) {
-		log_message(LOGLVL_WARNING, "Could not accept new connection: %s", strerror(errno));
-		return TRUE;
-	}
-
-	if (global.conf->runmode == RUNMODE_FORKDAEMON) {
-		pid_t client_pid = 0;
-		int fds[2];
-
-		if (socketpair(AF_UNIX, SOCK_STREAM, 0, fds) == -1) {
-			log_message(LOGLVL_WARNING, "Could not create IPC socket for client: %s", strerror(errno));
-			fds[0] = fds[1] = -1;
-		}
-
-		sock_make_nonblocking(fds[0]);
-		sock_make_nonblocking(fds[1]);
-
-		client_pid = fork();
-
-		if (client_pid > 0 && fds[0] != -1) {
-			struct bitlbee_child *child;
-
-			/* TODO: Stuff like this belongs in ipc.c. */
-			child = g_new0(struct bitlbee_child, 1);
-			child->pid = client_pid;
-			child->ipc_fd = fds[0];
-			child->ipc_inpa = b_input_add(child->ipc_fd, B_EV_IO_READ, ipc_master_read, child);
-			child->to_fd = -1;
-			child_list = g_slist_append(child_list, child);
-
-			log_message(LOGLVL_INFO, "Creating new subprocess with pid %d.", (int) client_pid);
-
-			/* Close some things we don't need in the parent process. */
-			close(new_socket);
-			close(fds[1]);
-		} else if (client_pid == 0) {
-			irc_t *irc;
-
-			b_main_init();
-
-			/* Close the listening socket, we're a client. */
-			close(global.listen_socket);
-			b_event_remove(global.listen_watch_source_id);
-
-			/* Make a new pipe for the shutdown signal handler */
-			sighandler_shutdown_setup();
-
-			/* Make the connection. */
-			irc = irc_new(new_socket);
-
-			/* We can store the IPC fd there now. */
-			global.listen_socket = fds[1];
-			global.listen_watch_source_id = b_input_add(fds[1], B_EV_IO_READ, ipc_child_read, irc);
-
-			close(fds[0]);
-
-			ipc_master_free_all();
-		}
-	} else {
-		log_message(LOGLVL_INFO, "Creating new connection with fd %d.", new_socket);
-		irc_new(new_socket);
-	}
-
-	return TRUE;
-}
-
-gboolean bitlbee_shutdown(gpointer data, gint fd, b_input_condition cond)
-{
-	/* Send the message here with now=TRUE to ensure it arrives */
-	irc_write_all(TRUE, "ERROR :Closing link: BitlBee server shutting down");
-
+		return( FALSE );
+	}
+	else
+	{
+		temp = g_strdup( irc->sendbuffer + st );
+		g_free( irc->sendbuffer );
+		irc->sendbuffer = temp;
+		
+		return( TRUE );
+	}
+}
+
+int bitlbee_load( irc_t *irc, char* password )
+{
+	char s[512];
+	char *line;
+	int proto;
+	char nick[MAX_NICK_LENGTH+1];
+	FILE *fp;
+	user_t *ru = user_find( irc, ROOT_NICK );
+	
+	if( irc->status == USTATUS_IDENTIFIED )
+		return( 1 );
+	
+	g_snprintf( s, 511, "%s%s%s", global.conf->configdir, irc->nick, ".accounts" );
+   	fp = fopen( s, "r" );
+   	if( !fp ) return( 0 );
+	
+	fscanf( fp, "%32[^\n]s", s );
+	if( setpass( irc, password, s ) < 0 )
+	{
+		fclose( fp );
+		return( -1 );
+	}
+	
+	/* Do this now. If the user runs with AuthMode = Registered, the
+	   account command will not work otherwise. */
+	irc->status = USTATUS_IDENTIFIED;
+	
+	while( fscanf( fp, "%511[^\n]s", s ) > 0 )
+	{
+		fgetc( fp );
+		line = deobfucrypt( irc, s );
+		root_command_string( irc, ru, line, 0 );
+		g_free( line );
+	}
+	fclose( fp );
+	
+	g_snprintf( s, 511, "%s%s%s", global.conf->configdir, irc->nick, ".nicks" );
+	fp = fopen( s, "r" );
+	if( !fp ) return( 0 );
+	while( fscanf( fp, "%s %d %s", s, &proto, nick ) > 0 )
+	{
+		http_decode( s );
+		nick_set( irc, s, proto, nick );
+	}
+	fclose( fp );
+	
+	if( set_getint( irc, "auto_connect" ) )
+	{
+		strcpy( s, "account on" );	/* Can't do this directly because r_c_s alters the string */
+		root_command_string( irc, ru, s, 0 );
+	}
+	
+	return( 1 );
+}
+
+int bitlbee_save( irc_t *irc )
+{
+	char s[512];
+	char path[512], new_path[512];
+	char *line;
+	nick_t *n;
+	set_t *set;
+	mode_t ou = umask( 0077 );
+	account_t *a;
+	FILE *fp;
+	char *hash;
+	
+	/*\
+	 *  [SH] Nothing should be saved if no password is set, because the
+	 *  password is not set if it was wrong, or if one is not identified
+	 *  yet. This means that a malicious user could easily overwrite
+	 *  files owned by someone else:
+	 *  a Bad Thing, methinks
+	\*/
+
+	/* [WVG] No? Really? */
+
+	/*\
+	 *  [SH] Okay, okay, it wasn't really Wilmer who said that, it was
+	 *  me. I just thought it was funny.
+	\*/
+	
+	hash = hashpass( irc );
+	if( hash == NULL )
+	{
+		irc_usermsg( irc, "Please register yourself if you want to save your settings." );
+		return( 0 );
+	}
+	
+	g_snprintf( path, 511, "%s%s%s", global.conf->configdir, irc->nick, ".nicks~" );
+	fp = fopen( path, "w" );
+	if( !fp ) return( 0 );
+	for( n = irc->nicks; n; n = n->next )
+	{
+		strcpy( s, n->handle );
+		s[169] = 0; /* Prevent any overflow (169 ~ 512 / 3) */
+		http_encode( s );
+		g_snprintf( s + strlen( s ), 510 - strlen( s ), " %d %s", n->proto, n->nick );
+		if( fprintf( fp, "%s\n", s ) != strlen( s ) + 1 )
+		{
+			irc_usermsg( irc, "fprintf() wrote too little. Disk full?" );
+			fclose( fp );
+			return( 0 );
+		}
+	}
+	if( fclose( fp ) != 0 )
+	{
+		irc_usermsg( irc, "fclose() reported an error. Disk full?" );
+		return( 0 );
+	}
+  
+	g_snprintf( new_path, 512, "%s%s%s", global.conf->configdir, irc->nick, ".nicks" );
+	if( unlink( new_path ) != 0 )
+	{
+		if( errno != ENOENT )
+		{
+			irc_usermsg( irc, "Error while removing old .nicks file" );
+			return( 0 );
+		}
+	}
+	if( rename( path, new_path ) != 0 )
+	{
+		irc_usermsg( irc, "Error while renaming new .nicks file" );
+		return( 0 );
+	}
+	
+	g_snprintf( path, 511, "%s%s%s", global.conf->configdir, irc->nick, ".accounts~" );
+	fp = fopen( path, "w" );
+	if( !fp ) return( 0 );
+	if( fprintf( fp, "%s", hash ) != strlen( hash ) )
+	{
+		irc_usermsg( irc, "fprintf() wrote too little. Disk full?" );
+		fclose( fp );
+		return( 0 );
+	}
+	g_free( hash );
+
+	for( a = irc->accounts; a; a = a->next )
+	{
+		if( a->protocol == PROTO_OSCAR || a->protocol == PROTO_ICQ || a->protocol == PROTO_TOC )
+			g_snprintf( s, sizeof( s ), "account add oscar \"%s\" \"%s\" %s", a->user, a->pass, a->server );
+		else
+			g_snprintf( s, sizeof( s ), "account add %s \"%s\" \"%s\" \"%s\"",
+			            proto_name[a->protocol], a->user, a->pass, a->server ? a->server : "" );
+		
+		line = obfucrypt( irc, s );
+		if( *line )
+		{
+			if( fprintf( fp, "%s\n", line ) != strlen( line ) + 1 )
+			{
+				irc_usermsg( irc, "fprintf() wrote too little. Disk full?" );
+				fclose( fp );
+				return( 0 );
+			}
+		}
+		g_free( line );
+	}
+	
+	for( set = irc->set; set; set = set->next )
+	{
+		if( set->value && set->def )
+		{
+			g_snprintf( s, sizeof( s ), "set %s \"%s\"", set->key, set->value );
+			line = obfucrypt( irc, s );
+			if( *line )
+			{
+				if( fprintf( fp, "%s\n", line ) != strlen( line ) + 1 )
+				{
+					irc_usermsg( irc, "fprintf() wrote too little. Disk full?" );
+					fclose( fp );
+					return( 0 );
+				}
+			}
+			g_free( line );
+		}
+	}
+	
+	if( strcmp( irc->mynick, ROOT_NICK ) != 0 )
+	{
+		g_snprintf( s, sizeof( s ), "rename %s %s", ROOT_NICK, irc->mynick );
+		line = obfucrypt( irc, s );
+		if( *line )
+		{
+			if( fprintf( fp, "%s\n", line ) != strlen( line ) + 1 )
+			{
+				irc_usermsg( irc, "fprintf() wrote too little. Disk full?" );
+				fclose( fp );
+				return( 0 );
+			}
+		}
+		g_free( line );
+	}
+	if( fclose( fp ) != 0 )
+	{
+		irc_usermsg( irc, "fclose() reported an error. Disk full?" );
+		return( 0 );
+	}
+	
+ 	g_snprintf( new_path, 512, "%s%s%s", global.conf->configdir, irc->nick, ".accounts" );
+ 	if( unlink( new_path ) != 0 )
+	{
+		if( errno != ENOENT )
+		{
+			irc_usermsg( irc, "Error while removing old .accounts file" );
+			return( 0 );
+		}
+	}
+	if( rename( path, new_path ) != 0 )
+	{
+		irc_usermsg( irc, "Error while renaming new .accounts file" );
+		return( 0 );
+	}
+	
+	umask( ou );
+	
+	return( 1 );
+}
+
+void bitlbee_shutdown( gpointer data )
+{
 	/* Try to save data for all active connections (if desired). */
-	while (irc_connection_list != NULL) {
-		irc_abort(irc_connection_list->data, TRUE, NULL);
-	}
-
+	while( irc_connection_list != NULL )
+		irc_free( irc_connection_list->data );
+	
 	/* We'll only reach this point when not running in inetd mode: */
-	b_main_quit();
-
-	return FALSE;
-}
+	g_main_quit( global.loop );
+}
+
+int root_command_string( irc_t *irc, user_t *u, char *command, int flags )
+{
+	char *cmd[IRC_MAX_ARGS];
+	char *s;
+	int k;
+	char q = 0;
+	
+	memset( cmd, 0, sizeof( cmd ) );
+	cmd[0] = command;
+	k = 1;
+	for( s = command; *s && k < ( IRC_MAX_ARGS - 1 ); s ++ )
+		if( *s == ' ' && !q )
+		{
+			*s = 0;
+			while( *++s == ' ' );
+			if( *s == '"' || *s == '\'' )
+			{
+				q = *s;
+				s ++;
+			}
+			if( *s )
+			{
+				cmd[k++] = s;
+				s --;
+			}
+		}
+		else if( *s == q )
+		{
+			q = *s = 0;
+		}
+	cmd[k] = NULL;
+	
+	return( root_command( irc, cmd ) );
+}
+
+int root_command( irc_t *irc, char *cmd[] )
+{	
+	int i;
+	
+	if( !cmd[0] )
+		return( 0 );
+	
+	for( i = 0; commands[i].command; i++ )
+		if( g_strcasecmp( commands[i].command, cmd[0] ) == 0 )
+		{
+			if( !cmd[commands[i].required_parameters] )
+			{
+				irc_usermsg( irc, "Not enough parameters given (need %d)", commands[i].required_parameters );
+				return( 0 );
+			}
+			commands[i].execute( irc, cmd );
+			return( 1 );
+		}
+	
+	irc_usermsg( irc, "Unknown command: %s. Please use help commands to get a list of available commands.", cmd[0] );
+	
+	return( 1 );
+}
+
+/* Decode%20a%20file%20name						*/
+void http_decode( char *s )
+{
+	char *t;
+	int i, j, k;
+	
+	t = g_new( char, strlen( s ) + 1 );
+	
+	for( i = j = 0; s[i]; i ++, j ++ )
+	{
+		if( s[i] == '%' )
+		{
+			if( sscanf( s + i + 1, "%2x", &k ) )
+			{
+				t[j] = k;
+				i += 2;
+			}
+			else
+			{
+				*t = 0;
+				break;
+			}
+		}
+		else
+		{
+			t[j] = s[i];
+		}
+	}
+	t[j] = 0;
+	
+	strcpy( s, t );
+	g_free( t );
+}
+
+/* Warning: This one explodes the string. Worst-cases can make the string 3x its original size! */
+/* This fuction is safe, but make sure you call it safely as well! */
+void http_encode( char *s )
+{
+	char *t;
+	int i, j;
+	
+	t = g_strdup( s );
+	
+	for( i = j = 0; t[i]; i ++, j ++ )
+	{
+		if( t[i] <= ' ' || ((unsigned char *)t)[i] >= 128 || t[i] == '%' )
+		{
+			sprintf( s + j, "%%%02X", ((unsigned char*)t)[i] );
+			j += 2;
+		}
+		else
+		{
+			s[j] = t[i];
+		}
+	}
+	s[j] = 0;
+	
+	g_free( t );
+}
+
+/* Strip newlines from a string. Modifies the string passed to it. */ 
+char *strip_newlines( char *source )
+{
+	int i;	
+
+	for( i = 0; source[i] != '\0'; i ++ )
+		if( source[i] == '\n' || source[i] == '\r' )
+			source[i] = 32;
+	
+	return source;
+}
Index: bitlbee.conf
===================================================================
--- bitlbee.conf	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ bitlbee.conf	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -10,34 +10,18 @@
 ##
 ##  Inetd -- Run from inetd (default)
-##  Daemon -- Run as a stand-alone daemon, serving all users from one process.
-##    This saves memory if there are more users, the downside is that when one
-##    user hits a crash-bug, all other users will also lose their connection.
-##  ForkDaemon -- Run as a stand-alone daemon, but keep all clients in separate
-##    child processes. This should be pretty safe and reliable to use instead
-##    of inetd mode.
+##  Daemon -- Run as a stand-alone daemon -- EXPERIMENTAL! BitlBee is not yet
+##    stable enough to serve lots of users from one process. Because of this
+##    and other reasons, the use of daemon-mode is *STRONGLY* discouraged,
+##    don't think about reporting bugs when you use this!
 ##
 # RunMode = Inetd
 
-## User:
-## 
-## If BitlBee is started by root as a daemon, it can drop root privileges,
-## and change to the specified user.
-##
-# User = bitlbee
-
 ## DaemonPort/DaemonInterface:
 ##
-## For daemon mode, you can specify on what interface and port the daemon
-## should be listening for connections.
+## For RunMode=Daemon, here you can specify on what interface and port the
+## daemon should be listening for connections.
 ##
 # DaemonInterface = 0.0.0.0
 # DaemonPort = 6667
-
-## ClientInterface:
-##
-## If for any reason, you want BitlBee to use a specific address/interface
-## for outgoing traffic (IM connections, HTTP(S), etc.), set it here.
-##
-# ClientInterface = 0.0.0.0
 
 ## AuthMode
@@ -48,51 +32,13 @@
 ##    allowing the user to connect at all.
 ##  Registered -- Only allow registered users to use this server; this disables
-##    the register- and the account command until the user identifies itself.
+##    the register- and the account command until the user identifies himself.
 ##
 # AuthMode = Open
-
-## AuthBackend
-##
-## By default, the authentication data for a user is stored in the storage
-## backend. If you want to authenticate against another authentication system
-## (e.g. ldap), you can specify that here.
-##
-## Beware that this disables password changes and causes passwords for the
-## accounts people create to be stored in plain text instead of encrypted with
-## their bitlbee password.
-##
-## Currently available backends:
-##
-## - storage (internal storage)
-## - pam (Linux PAM authentication)
-## - ldap (LDAP server configured in the openldap settings)
-#
-# AuthBackend = storage
-#
 
 ## AuthPassword
 ##
 ## Password the user should enter when logging into a closed BitlBee server.
-## You can also have a BitlBee-style MD5 hash here. Format: "md5:", followed
-## by a hash as generated by "bitlbee -x hash <password>".
 ##
 # AuthPassword = ItllBeBitlBee   ## Heh.. Our slogan. ;-)
-## or
-# AuthPassword = md5:gzkK0Ox/1xh+1XTsQjXxBJ571Vgl
-
-## OperPassword
-##
-## Password that unlocks access to special operator commands.
-##
-# OperPassword = ChangeMe!
-## or
-# OperPassword = md5:I0mnZbn1t4R731zzRdDN2/pK7lRX
-
-## AllowAccountAdd
-##
-## Whether to allow registered and identified users to add new accounts using
-## 'account add'
-##
-# AllowAccountAdd 1
 
 ## HostName
@@ -100,5 +46,6 @@
 ## Normally, BitlBee gets a hostname using getsockname(). If you have a nicer
 ## alias for your BitlBee daemon, you can set it here and BitlBee will identify
-## itself with that name instead.
+## itself with that name instead. Leave it commented out if you want BitlBee to
+## use getsockname() to get a hostname.
 ##
 # HostName = localhost
@@ -142,31 +89,8 @@
 ## (Obviously, the username and password are optional)
 ##
-# Proxy = http://john:doe@proxy.localnet.com:8080
-# Proxy = socks4://socksproxy.localnet.com
-# Proxy = socks5://socksproxy.localnet.com
+## Proxy = http://john:doe@proxy.localnet.com:8080
+## Proxy = socks4://socksproxy.localnet.com
+## Proxy = socks5://socksproxy.localnet.com
 
-## Protocols offered by bitlbee
-## 
-## As recompiling may be quite unpractical for some people, this option
-## allows to remove the support of protocol, even if compiled in. If
-## nothing is given, there are no restrictions.
-## 
-# Protocols = jabber yahoo
-
-## Trusted CAs
-##
-## Path to a file containing a list of trusted certificate authorities used in
-## the verification of server certificates.
-##
-## Uncomment this and make sure the file actually exists and contains all
-## certificate authorities you're willing to accept (default value should
-## work on at least Debian/Ubuntu systems with the "ca-certificates" package
-## installed). As long as the line is commented out, SSL certificate
-## verification is completely disabled.
-##
-## The location of this file may be different on other distros/OSes. For
-## example, try /etc/ssl/ca-bundle.pem on OpenSUSE.
-##
-# CAfile = /etc/ssl/certs/ca-certificates.crt
 
 [defaults]
